SU(1)

NAME
su - substitute user identity

SYNOPSIS
su [-Kflm] [login [args]]

DESCRIPTION
Su requests the Kerberos password for login (or for “login.root”, if no login is provided), and switches to that user and group ID after obtaining a Kerberos ticket granting ticket. A shell is then executed. Su will resort to the local password file to find the password for login if there is a Kerberos error. If su is executed by root, no password is requested and a shell with the appropriate user ID is executed; no additional Kerberos tickets are obtained.

By default, the environment is unmodified with the exception of USER, HOME, and SHELL. HOME and SHELL are set to the target login's default values. USER is set to the target login, unless the target login has a user ID of 0, in which case it is unmodified. The invoked shell is the target login's. This is the traditional behavior of su.

The options are as follows:

-K  Do not attempt to use Kerberos to authenticate the user.

-f  If the invoked shell is csh(1), this option prevents it from reading the “.cshrc” file.

-l  Simulate a full login. The environment is discarded except for HOME, SHELL, PATH, TERM, and USER. HOME and SHELL are modified as above. USER is set to the target login. PATH is set to “/bin:/usr/bin”. TERM is imported from your current environment. The invoked shell is the target login's, and su will change directory to the target login's home directory.

-m  Leave the environment unmodified. The invoked shell is your login shell, and no directory changes are made. As a security precaution, if the target user's shell is a non-standard shell (as defined by getusershell(3)) and the caller's real uid is non-zero, su will fail.

The -l and -m options are mutually exclusive; the last one specified overrides any previous ones.

If the optional args are provided on the command line, they are passed to the login shell of the target login. This allows it to pass arbitrary commands via the -c option as understood by most shells. Note that -c usually expects a single argument only; you have to quote it when passing multiple words.

Only users in group 0 (normally “wheel”) can su to “root”.

By default (unless the prompt is reset by a startup file) the super-user prompt is set to “#” to remind one of its awesome power.

SEE ALSO
csh(1), login(1), sh(1), kinit(1), kerberos(1), passwd(5), group(5), environ(7)

ENVIRONMENT
Environment variables used by su:

HOME
    Default home directory of real user ID unless modified as specified above.

PATH
    Default search path of real user ID unless modified as specified above.

TERM
    Provides terminal type which may be retained for the substituted user ID.

USER
    The user ID is always the effective ID (the target user ID) after an su unless the user ID is 0 (root).

EXAMPLES
su man -c catman
    Runs the command catman as user man. You will be asked for man's password unless your real UID is 0.
su man -c 'catman /usr/share/man /usr/local/man /usr/X11R6/man'
    Same as above, but the target command constitutes of more than a single word.
su -l foo
    Pretend a login for user foo.

HISTORY
A su command appeared in AT&T UNIX.